Index: /trunk/src/samhain_hide.c
===================================================================
--- /trunk/src/samhain_hide.c	(revision 1)
+++ /trunk/src/samhain_hide.c	(revision 1)
@@ -0,0 +1,780 @@
+/***************************************************************************
+ *
+ * Purpose:
+ * -------
+ *   (1) Hide files with the string MAGIC_HIDE in filename,
+ *       where MAGIC_HIDE is defined below. 
+ *       By default,  MAGIC_HIDE is defined as "samhain".
+ *
+ *   (2) Hide all processes, if the executable has the string MAGIC_HIDE 
+ *       in its name.
+ *
+ *
+ * Configuration:
+ * -------------
+ *   If not building within the samhain system, you may remove the 
+ *   line '#include "config.h"' and in the line
+ *   '#define MAGIC_HIDE SH_MAGIC_HIDE', replace SH_MAGIC_HIDE with
+ *   "someString" (in quotes !).
+ */
+
+/* #define _(string) string */
+#include "config.h" 
+
+#undef _
+#define _(string) string
+
+/* define if this is a 2.6 kernel                 */
+/* #define LINUX26                                */
+
+#define MAGIC_HIDE SH_MAGIC_HIDE
+
+/*  #define MAGIC_HIDE "someString"               */
+
+/* define this if you have a modversioned kernel  */
+/*  #define MODVERSIONS                           */
+
+/* the address of the sys_call_table (not exported in 2.5 kernels) */
+#define MAGIC_ADDRESS SH_SYSCALLTABLE
+
+/*
+ * Install:
+ * -------
+ *   gcc -Wall -O2 -c samhain_hide.c
+ *   mv samhain_hide.o  /lib/modules/KERNEL_VERSION/misc/
+ *   
+ *   (Replace KERNEL_VERSION with your kernel's version.)
+ *
+ * Usage:
+ * -----
+ *   To load the module:
+ *    insmod samhain_hide (for improved safety: 'sync && insmod samhain_hide')
+ *
+ *   To unload the module 
+ *    rmmod samhain_hide  (for improved safety: 'sync && rmmod samhain_hide')
+ * 
+ *
+ * Details:
+ * -------
+ *   The following kernel syscalls are replaced:
+ *     sys_getdents     [hide files/directories/processes (/proc/PID)]
+ * 
+ * Tested on:
+ * ---------
+ *   Linux 2.2, 2.4, 2.6
+ *
+ * Copyright:
+ * ---------
+ *   Copyright (C) 2001, 2002 Rainer Wichmann (http://la-samhna.de)
+ *
+ * License: 
+ * -------
+ *   This program is free software; you can redistribute it and/or modify
+ *   it under the terms of the GNU General Public License, version 2, as
+ *   published by the Free Software Foundation.
+ *                                                                         
+ *   This program is distributed in the hope that it will be useful,        
+ *   but WITHOUT ANY WARRANTY; without even the implied warranty of         
+ *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          
+ *   GNU General Public License for more details.                           
+ *                                                                         
+ *   You should have received a copy of the GNU General Public License      
+ *   along with this program; if not, write to the Free Software            
+ *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.              
+ *
+ ***************************************************************************/
+
+
+
+/*****************************************************
+ *
+ *  The defines:
+ *
+ *****************************************************/
+
+/* This is a Linux Loadable Kernel Module.
+ */
+
+#ifndef LINUX26
+#define __KERNEL__
+#define MODULE
+#endif
+#define LINUX
+
+/* Define for debugging.   
+ */
+/* #define HIDE_DEBUG  */   /* query_module */
+/* #define FILE_DEBUG  */   /* getdents     */
+/* #define READ_DEBUG  */   /* read         */
+/* #define PROC_DEBUG  */   /* procfs       */
+
+
+/*****************************************************
+ *
+ *  The include files:
+ *
+ *****************************************************/
+
+
+/* The configure options (#defines) for the Kernel
+ */
+#include <linux/config.h>
+
+#ifndef LINUX26
+#ifdef CONFIG_MODVERSIONS
+#include <linux/modversions.h>
+#endif
+#endif
+
+
+#ifdef LINUX26
+#include <linux/init.h>
+#endif
+
+#include <linux/module.h>
+
+/* File tables structures. If directory caching is used,
+ * <linux/dcache.h> will be included here, and __LINUX_DCACHE_H
+ * will thus be defined.
+ */
+#include <linux/fs.h>
+#include <linux/proc_fs.h>
+
+/* Include the SYS_syscall defines.
+ */
+#ifndef LINUX26
+#include <sys/syscall.h>
+#else
+#define SYS_getdents 141
+#define SYS_getdents64 220
+#endif
+
+
+/* Includes for 'getdents' per the manpage.
+ */
+#include <linux/types.h>
+#include <linux/dirent.h>
+#include <linux/unistd.h>
+
+/* To access userspace memory.
+ */
+#include <asm/uaccess.h>
+
+/* Include for lock_kernel().
+ */
+#include <linux/smp_lock.h>
+
+/* Include for fget().
+ */
+#include <linux/file.h>
+
+/*****************************************************
+ *
+ *  The global variables:
+ *
+ *****************************************************/
+
+/* The kernel syscall table. Not exported anymore in 2.5 ff., and also
+ * not in the RedHat 2.4 kernel.
+ */
+
+#if 0
+extern void * sys_call_table[];
+#define sh_sys_call_table sys_call_table
+#endif
+
+unsigned long * sh_sys_call_table = (unsigned long *) MAGIC_ADDRESS;
+
+/* The old address of the sys_getdents syscall.
+ */
+int (*old_getdents)(unsigned int, struct dirent *, unsigned int);
+#ifdef __NR_getdents64
+long (*old_getdents64)(unsigned int, struct dirent64 *, unsigned int);
+#endif
+
+char hidden[] = MAGIC_HIDE;
+ 
+
+/*****************************************************
+ *
+ *  The functions:
+ *
+ *****************************************************/
+
+
+MODULE_AUTHOR("Rainer Wichmann");
+MODULE_DESCRIPTION("Hide files/processes/modules with MAGIC_HIDE in name.");
+#if defined(MODULE_LICENSE) || defined(LINUX26)
+MODULE_LICENSE("GPL");  
+#endif
+
+#ifdef LINUX26
+/* Default is to hide ourselves.
+ */
+static int removeme = 1;
+
+MODULE_PARM (removeme, "i");
+#endif
+
+
+/* 
+ *  struct task_struct is defined in linux/sched.h
+ *
+ *  as of 2.4.20, the vanilla kernel holds (among others):
+ *        struct task_struct *next_task, *prev_task;
+ *
+ *  Redhat kernel seems to have a different scheduler.
+ *  use:
+ *        struct task_struct * find_task_by_pid (int pid);
+ */
+
+#if defined(SH_VANILLA_KERNEL) && !defined(LINUX26)
+/*
+ * Fetch the task struct for a given PID.
+ */
+struct task_struct * fetch_task_struct (int pid)
+{
+  struct task_struct * task_ptr;
+
+#ifdef PROC_DEBUG
+  printk("FETCH TASK %d\n", pid);
+#endif
+
+  task_ptr = current;
+
+  do 
+    {
+      if (task_ptr->pid == (pid_t) pid )
+	return (task_ptr);
+      task_ptr = task_ptr->next_task;
+    } 
+  while (task_ptr != current);
+
+#ifdef PROC_DEBUG
+  printk("FETCH TASK: NOT FOUND !!!\n");
+#endif
+
+  return (NULL);
+}
+
+#else
+/*
+ *  RedHat 2.4.20 kernel
+ */
+struct task_struct * fetch_task_struct (int pid)
+{
+  struct task_struct * task_ptr = NULL;
+  task_ptr = find_task_by_pid (pid);
+  return (task_ptr);
+}
+#endif
+
+/* Convert a string to an int. 
+ * Does not recognize integers with a sign (+/-) in front.
+ */
+int my_atoi(char * in_str)
+{
+  int i      = 0;
+  int retval = 0;
+  int conv   = 0;
+
+  if (in_str == NULL)
+    return (-1);
+
+  while(in_str[i] != '\0')
+    {
+      /* Break if not numeric.
+       */
+      if (in_str[i] < '0' || in_str[i] > '9')
+	break;
+
+      ++conv;
+      
+      /* Leading zeroes (should not happen in /proc)
+       */
+      if (retval == 0 && in_str[i] == '0')
+	retval = retval;
+      else
+	retval = retval * 10;
+
+      retval = retval + (in_str[i] - '0');
+
+      i++;
+    }
+      
+  if (conv == 0)
+    return (-1);
+  else
+    return (retval); 
+}
+
+/* Purpose:
+ * 
+ *   Hide all files/dirs that include the string MAGIC_HIDE in their
+ *   name. 
+ */
+int new_getdents (unsigned int fd, struct dirent *dirp, unsigned int count)
+{
+  int                  status = 0;    /* Return value from original getdents */
+  struct inode       * dir_inode;
+  int                  dir_is_proc = 0;
+
+  struct dirent      * dirp_prev;
+  struct dirent      * dirp_new;
+  struct dirent      * dirp_current;
+
+  int                  dir_table_bytes;
+  int                  forward_bytes;
+  struct task_struct * task_ptr;
+  int                  hide_it = 0;
+  long                 dirp_offset;
+
+  lock_kernel();
+
+  status = (*old_getdents)(fd, dirp, count);
+
+#ifdef FILE_DEBUG
+  printk("STATUS %d\n", status);
+#endif
+
+  /*  0: end of directory.
+   * -1: some error
+   */
+  if (status <= 0)
+    {
+      unlock_kernel();
+      return (status);
+    }
+
+  /* Handle directory caching. dir_inode is the inode of the directory.
+   */
+#if defined(__LINUX_DCACHE_H)
+  dir_inode  = current->files->fd[fd]->f_dentry->d_inode;
+#else
+  dir_inode  = current->files->fd[fd]->f_inode;
+#endif
+
+  /* Check for the /proc directory
+   */
+  if (dir_inode->i_ino == PROC_ROOT_INO 
+#ifndef LINUX26
+      && !MAJOR(dir_inode->i_dev) && 
+      MINOR(dir_inode->i_dev) == 1
+#endif
+      )
+    dir_is_proc = 1;
+
+  /* Allocate space for new dirent table. Can't use GFP_KERNEL 
+   * (kernel oops)
+   */
+  dirp_new = (struct dirent *) kmalloc (status, GFP_ATOMIC);
+
+  if (dirp_new == NULL)
+    {
+      unlock_kernel();
+      return (status);
+    }
+
+  /* Copy the dirp table to kernel space.
+   */
+  copy_from_user(dirp_new, dirp, status);
+
+#ifdef FILE_DEBUG
+  printk("COPY to kernel\n");
+#endif
+
+  /* Loop over the dirp table to find entries to hide.
+   */
+  dir_table_bytes = status;
+  dirp_current    = dirp_new;
+  dirp_prev       = NULL;
+
+  while (dir_table_bytes > 0)
+    {
+      hide_it = 0;
+
+      if (dirp_current->d_reclen == 0)
+	break;
+
+      dirp_offset = dirp_current->d_off;
+      
+#ifdef FILE_DEBUG
+      printk("DIRENT %d  %d  %ld\n", 
+	     dir_table_bytes,
+	     dirp_current->d_reclen,
+	     dirp_current->d_off);
+#endif
+
+      dir_table_bytes -= dirp_current->d_reclen;
+      forward_bytes    = dirp_current->d_reclen;
+
+#ifdef FILE_DEBUG
+      printk("ENTRY %s\n", dirp_current->d_name);
+#endif
+
+      /* If /proc is scanned (e.g. by 'ps'), hide the entry for
+       * any process where the executable has MAGIC_HIDE in its name.
+       */
+      if (dir_is_proc == 1)
+	{
+	  task_ptr = fetch_task_struct(my_atoi(dirp_current->d_name));
+	  if (task_ptr != NULL)
+	    {
+	      if (strstr(task_ptr->comm, hidden) != NULL)
+		hide_it = 1;
+	    }
+	}
+      /* If it is a regular directory, hide any entry with
+       * MAGIC_HIDE in its name.
+       */
+      else
+	{
+	  if (strstr (dirp_current->d_name, hidden) != NULL)
+	    hide_it = 1;
+	}
+
+      if (hide_it == 1)
+	{
+#ifdef FILE_DEBUG
+	  printk("  -->HIDDEN %s\n", dirp_current->d_name);
+#endif
+	  if (dir_table_bytes > 0)
+	    {
+	      status -= dirp_current->d_reclen;
+	      memmove (dirp_current, 
+		       (char *) dirp_current + dirp_current->d_reclen, 
+		       dir_table_bytes);
+
+	      /* Set forward_bytes to 0, because now dirp_current is the
+	       * (previously) next entry in the dirp table.
+	       */
+	      forward_bytes    = 0;
+	      dirp_prev        = dirp_current;
+	    }
+	  else
+	    {
+	      status -= dirp_current->d_reclen;
+	      if (dirp_prev != NULL)
+		dirp_prev->d_off = dirp_offset;
+	    }
+	  
+	}
+      else
+	{
+	  dirp_prev        = dirp_current;
+	  if (dir_table_bytes == 0 && dirp_prev != NULL)
+	    dirp_prev->d_off = dirp_offset;
+	}
+
+      /* Next entry in dirp table.
+       */
+      if (dir_table_bytes > 0)
+	dirp_current = (struct dirent *) ( (char *) dirp_current + 
+					   forward_bytes);
+    }
+
+  /* Copy our modified dirp table back to user space.
+   */
+  copy_to_user(dirp, dirp_new, status);
+#ifdef FILE_DEBUG
+  printk("COPY to user\n");
+#endif
+
+  kfree (dirp_new);
+#ifdef FILE_DEBUG
+  printk("KFREE\n");
+#endif
+
+  unlock_kernel();
+  return (status);
+}
+
+
+/* For 2.4 kernel
+ */
+#ifdef __NR_getdents64
+long new_getdents64 (unsigned int fd, struct dirent64 *dirp, 
+		     unsigned int count)
+{
+  long                 status = 0;    /* Return value from original getdents */
+  struct inode       * dir_inode;
+  int                  dir_is_proc = 0;
+
+  struct dirent64    * dirp_prev;
+  struct dirent64    * dirp_new;
+  struct dirent64    * dirp_current;
+
+  int                  dir_table_bytes;
+  int                  forward_bytes;
+  struct task_struct * task_ptr;
+  int                  hide_it = 0;
+  __s64                dirp_offset;
+
+  lock_kernel();
+
+  status = (*old_getdents64)(fd, dirp, count);
+
+#ifdef FILE_DEBUG
+  printk("STATUS64 %ld\n", status);
+#endif
+
+  /*  0: end of directory.
+   * -1: some error
+   */
+  if (status <= 0)
+    {
+      unlock_kernel();
+      return (status);
+    }
+
+  /* Handle directory caching. dir_inode is the inode of the directory.
+   */
+#if defined(__LINUX_DCACHE_H)
+  dir_inode  = current->files->fd[fd]->f_dentry->d_inode;
+#else
+  dir_inode  = current->files->fd[fd]->f_inode;
+#endif
+
+#ifdef FILE_DEBUG
+  printk("INODE64\n");
+#endif
+
+  /* Check for the /proc directory
+   */
+  if (dir_inode->i_ino == PROC_ROOT_INO
+#ifndef LINUX26  
+      && !MAJOR(dir_inode->i_dev) /*  && 
+      MINOR(dir_inode->i_dev) == 1 */
+      /* MINOR commented out because of problems with 2.4.17 */
+#endif
+      )
+    {
+      dir_is_proc = 1;
+
+#ifdef PROC_DEBUG
+      printk("PROC_CHECK64\n");
+#endif
+    }
+
+  /* Allocate space for new dirent table. Can't use GFP_KERNEL 
+   * (kernel oops)
+   */
+  dirp_new = kmalloc ((size_t)status, GFP_ATOMIC);
+
+#ifdef FILE_DEBUG
+  printk("KMALLOC64_0\n");
+#endif
+
+  if (dirp_new == NULL)
+    {
+      unlock_kernel();
+      return (status);
+    }
+
+#ifdef FILE_DEBUG
+  printk("KMALLOC64\n");
+#endif
+
+  /* Copy the dirp table to kernel space.
+   */
+  copy_from_user(dirp_new, dirp, status);
+
+#ifdef FILE_DEBUG
+  printk("COPY64 to kernel\n");
+#endif
+
+  /* Loop over the dirp table to find entries to hide.
+   */
+  dir_table_bytes = status;
+  dirp_current    = dirp_new;
+  dirp_prev       = NULL;
+
+  while (dir_table_bytes > 0)
+    {
+      hide_it = 0;
+
+      if (dirp_current->d_reclen == 0)
+	break;
+
+      dirp_offset = dirp_current->d_off;
+      
+#ifdef FILE_DEBUG
+      printk("DIRENT %d  %d  %lld\n", 
+	     dir_table_bytes,
+	     dirp_current->d_reclen,
+	     dirp_current->d_off);
+#endif
+
+      dir_table_bytes -= dirp_current->d_reclen;
+      forward_bytes    = dirp_current->d_reclen;
+
+#ifdef FILE_DEBUG
+      printk("ENTRY %s\n", dirp_current->d_name);
+#endif
+
+      /* If /proc is scanned (e.g. by 'ps'), hide the entry for
+       * any process where the executable has MAGIC_HIDE in its name.
+       */
+      if (dir_is_proc == 1)
+	{
+#ifdef PROC_DEBUG
+	  printk("PROC %s\n", dirp_current->d_name);
+#endif
+	  task_ptr = fetch_task_struct(my_atoi(dirp_current->d_name));
+	  if (task_ptr != NULL)
+	    {
+#ifdef PROC_DEBUG
+	      printk("PROC %s <> %s\n", task_ptr->comm, hidden);
+#endif
+	      if (strstr(task_ptr->comm, hidden) != NULL)
+		hide_it = 1;
+	    }
+	}
+      /* If it is a regular directory, hide any entry with
+       * MAGIC_HIDE in its name.
+       */
+      else
+	{
+	  if (strstr (dirp_current->d_name, hidden) != NULL)
+	    hide_it = 1;
+	}
+
+      if (hide_it == 1)
+	{
+#ifdef FILE_DEBUG
+	  printk("  -->HIDDEN %s\n", dirp_current->d_name);
+#endif
+	  if (dir_table_bytes > 0)
+	    {
+	      status -= dirp_current->d_reclen;
+	      memmove (dirp_current, 
+		       (char *) dirp_current + dirp_current->d_reclen, 
+		       dir_table_bytes);
+
+	      /* Set forward_bytes to 0, because now dirp_current is the
+	       * (previously) next entry in the dirp table.
+	       */
+	      forward_bytes    = 0;
+	      dirp_prev        = dirp_current;
+	    }
+	  else
+	    {
+	      status -= dirp_current->d_reclen;
+	      if (dirp_prev != NULL)
+		dirp_prev->d_off = dirp_offset;
+	    }
+	  
+	}
+      else
+	{
+	  dirp_prev        = dirp_current;
+	  if (dir_table_bytes == 0 && dirp_prev != NULL)
+	    dirp_prev->d_off = dirp_offset;
+	}
+
+      /* Next entry in dirp table.
+       */
+      if (dir_table_bytes > 0)
+	dirp_current = (struct dirent64 *) ( (char *) dirp_current + 
+					     forward_bytes);
+    }
+
+  /* Copy our modified dirp table back to user space.
+   */
+  copy_to_user(dirp, dirp_new, status);
+  kfree (dirp_new);
+  unlock_kernel();
+  return (status);
+}
+#endif
+
+#ifdef LINUX26
+static struct module *find_module(const char *name)
+{
+        struct module *mod;
+	struct list_head * modules = (struct list_head *) SH_LIST_MODULES;
+
+        list_for_each_entry(mod, modules, list) {
+                if (strcmp(mod->name, name) == 0)
+                        return mod;
+        }
+        return NULL;
+}
+#endif
+
+/* The initialisation function. Automatically called when module is inserted
+ * via the 'insmod' command.
+ */
+#ifdef LINUX26
+static int __init samhain_hide_init(void)
+#else
+int init_module(void)
+#endif
+{
+
+  lock_kernel();
+
+  /* Unfortunately this does not fully prevent the module from appearing
+   * in /proc/ksyms. 
+   */
+#ifndef LINUX26
+  EXPORT_NO_SYMBOLS;
+#endif
+
+  /* Replace the 'sys_getdents' syscall with the new version.
+   */
+  old_getdents                        = (void*) sh_sys_call_table[SYS_getdents];
+  sh_sys_call_table[SYS_getdents]     = (unsigned long) new_getdents;
+  
+#ifdef __NR_getdents64
+  old_getdents64                      = (void*) sh_sys_call_table[SYS_getdents64];
+  sh_sys_call_table[SYS_getdents64]   = (unsigned long) new_getdents64;
+#endif
+
+#ifdef LINUX26
+  {
+    spinlock_t * modlist_lock = (spinlock_t * ) SH_MODLIST_LOCK;
+    struct module *mod = find_module(SH_INSTALL_NAME"_hide");
+    if (mod) {
+      /* Delete from various lists */
+      spin_lock_irq(modlist_lock);
+      if (removeme == 1)
+	{
+	  list_del(&mod->list);
+	}
+      spin_unlock_irq(modlist_lock);
+    }
+  }
+#endif
+
+  unlock_kernel();
+  return (0);
+}
+
+/* The cleanup function. Automatically called when module is removed
+ * via the 'rmmod' command.
+ */
+#ifdef LINUX26
+static void __exit samhain_hide_cleanup(void)
+#else
+void cleanup_module(void)
+#endif
+{
+  lock_kernel();
+
+  /* Restore the new syscalls to the original version.
+   */
+  sh_sys_call_table[SYS_getdents]     = (unsigned long) old_getdents;
+#ifdef __NR_getdents64
+  sh_sys_call_table[SYS_getdents64]   = (unsigned long) old_getdents64;
+#endif
+
+  unlock_kernel();
+}
+
+#ifdef LINUX26
+module_init(samhain_hide_init);
+module_exit(samhain_hide_cleanup);
+#endif
+
+
Index: /trunk/src/samhain_setpwd.c
===================================================================
--- /trunk/src/samhain_setpwd.c	(revision 584)
+++ /trunk/src/samhain_setpwd.c	(revision 1)
@@ -1,3 +1,8 @@
 #include "config_xor.h"
+
+#ifdef HAVE_BROKEN_INCLUDES
+#define _ANSI_C_SOURCE
+#define _POSIX_SOURCE
+#endif
 
 #include <stdio.h>
@@ -8,130 +13,8 @@
 #include <unistd.h>
 #include <sys/types.h>
-#include <signal.h>
-#include <sys/wait.h>
 #include <sys/stat.h>
 #include <fcntl.h>
-#include <errno.h>
-#include <sys/time.h>
 #include <time.h>
 
-#if defined(HAVE_SCHED_H) && defined(HAVE_SCHED_YIELD)
-#include <sched.h>
-#endif
-
-#if defined(HAVE_INT_32)
-typedef unsigned int UINT32;
-#elif defined(HAVE_LONG_32)
-typedef unsigned long UINT32;
-#elif defined(HAVE_SHORT_32)
-typedef unsigned short UINT32;
-#endif
-
-#define TAUS_MAX 4294967295UL
-
-static UINT32 taus_state[3];
-
-static UINT32 taus_get ()
-{
-
-#define TAUSWORTHE(s,a,b,c,d) ((s &c) <<d) ^ (((s <<a) ^s) >>b)
-  taus_state[0] = TAUSWORTHE (taus_state[0], 13, 19, 4294967294UL, 12);
-  taus_state[1] = TAUSWORTHE (taus_state[1],  2, 25, 4294967288UL,  4);
-  taus_state[2] = TAUSWORTHE (taus_state[2],  3, 11, 4294967280UL, 17);
-  return (taus_state[0] ^ taus_state[1] ^ taus_state[2]);
-}
-
-static void taus_seed ()
-{
-  unsigned char buf[12];
-  unsigned char buf2[12];
-  unsigned char buf3[12];
-  ssize_t count;
-  size_t nbytes = sizeof(buf);
-  size_t where  = 0;
-
-  struct timeval t1, t2;
-  UINT32 delta, k[3];
-  int i, j;
-
-  int fd = open ("/dev/urandom", O_RDONLY);
-
-  if (fd == -1)
-    {
-      gettimeofday(&t1, NULL);
-      delta = t1.tv_usec;
-      memcpy(&buf[0], &delta, 4);
-      gettimeofday(&t1, NULL);
-      delta = t1.tv_usec;
-      memcpy(&buf[4], &delta, 4);
-      gettimeofday(&t1, NULL);
-      delta = t1.tv_usec;
-      memcpy(&buf[8], &delta, 4);
-      goto second;
-    }
-
-  do {
-    count = read(fd, &buf[where], nbytes);
-    if (count == -1 && errno == EINTR)
-      continue;
-    where  += count;
-    nbytes -= count;
-  } while (nbytes);
-
-  close(fd);
-
- second:
-  for (i = 0; i < 12; ++i)
-    {
-      gettimeofday(&t1, NULL);
-      if (0 == fork())
-	_exit(EXIT_SUCCESS);
-      wait(NULL);
-      gettimeofday(&t2, NULL);
-      delta = t2.tv_usec - t1.tv_usec;
-      buf2[i] = (unsigned char) delta;
-    }
-
-  for (i = 0; i < 12; ++i)
-    {
-      gettimeofday(&t1, NULL);
-      for (j = 0; j < 32768; ++j)
-	{
-	  if (0 == kill (j,0))
-	    k[i % 3] ^= j;
-	}
-      gettimeofday(&t2, NULL);
-      delta = t2.tv_usec - t1.tv_usec;
-      buf3[i] ^= (unsigned char) delta;
-    }
-
-  memcpy(&taus_state[0], &buf3[0], 4);
-  memcpy(&taus_state[1], &buf3[4], 4);
-  memcpy(&taus_state[2], &buf3[8], 4);
-
-  taus_state[0] ^= k[0];
-  taus_state[1] ^= k[1];
-  taus_state[2] ^= k[2];
-  
-  memcpy(&k[0], &buf2[0], 4);
-  memcpy(&k[1], &buf2[4], 4);
-  memcpy(&k[2], &buf2[8], 4);
-
-  taus_state[0] ^= k[0];
-  taus_state[1] ^= k[1];
-  taus_state[2] ^= k[2];
-  
-  memcpy(&k[0], &buf[0], 4);
-  memcpy(&k[1], &buf[4], 4);
-  memcpy(&k[2], &buf[8], 4);
-
-  taus_state[0] ^= k[0];
-  taus_state[1] ^= k[1];
-  taus_state[2] ^= k[2];
-
-  taus_state[0] |= (UINT32) 0x03;
-  taus_state[1] |= (UINT32) 0x09;
-  taus_state[2] |= (UINT32) 0x17;
-}
 
 #ifdef SH_STEALTH
@@ -229,8 +112,6 @@
 
   char * newn;
-  size_t nlen;
   int    oldf;
   int    newf;
-  int    ret;
 
   unsigned long bytecount;
@@ -246,32 +127,32 @@
   char * oldpwd = (char *) malloc(5 * 8 + 2); 
 
-  memset (newpwd, 0, 5 * 8 + 2); 
-  memset (oldpwd, 0, 5 * 8 + 2); 
+  memset (newpwd, '\0', 5 * 8 + 2); 
+  memset (oldpwd, '\0', 5 * 8 + 2); 
 
 
   if (argc < 4) 
     {
-      fprintf (stderr, "%s", _("\nUsage: samhain_setpwd <filename> <suffix> "\
+      fprintf (stderr, _("\nUsage: samhain_setpwd <filename> <suffix> "\
 	       "<new_password>\n\n"));
-      fprintf (stderr, "%s", _("   This program is a utility that will:\n"));
-      fprintf (stderr, "%s", _("    - search in the binary executable "\
-	       "<filename> for samhain's\n"));
-      fprintf (stderr, "%s", _("      compiled-in default password,\n"));
-      fprintf (stderr, "%s", _("    - change it to <new_password>,\n"));
-      fprintf (stderr, "%s", _("    - and output the modified binary to "\
+      fprintf (stderr, _("   This program is a utility that will:\n"));
+      fprintf (stderr, _("    - search in the binary executable <filename> "\
+	       "for samhain's\n"));
+      fprintf (stderr, _("      compiled-in default password,\n"));
+      fprintf (stderr, _("    - change it to <new_password>,\n"));
+      fprintf (stderr, _("    - and output the modified binary to "\
 	       "<filename>.<suffix>\n\n"));
-      fprintf (stderr, "%s", _("   To allow for non-printable chars, "\
+      fprintf (stderr, _("   To allow for non-printable chars, "\
 			 "<new_password> must be\n")); 
-      fprintf (stderr, "%s", _("   a 16-digit hexadecimal "\
+      fprintf (stderr, _("   a 16-digit hexadecimal "\
 	       "number (only 0-9,A-F allowed in input),\n"));
-      fprintf (stderr, "%s", _("   thus corresponding"\
+      fprintf (stderr, _("   thus corresponding"\
 			 "   to an 8-byte password.\n\n"));
-      fprintf (stderr, "%s", _("   Example: 'samhain_setpwd samhain new "\
+      fprintf (stderr, _("   Example: 'samhain_setpwd samhain new "\
 	       "4142434445464748'\n"));
-      fprintf (stderr, "%s", _("   takes the file 'samhain', sets the "\
-	       "password to 'ABCDEFGH'\n")); 
-      fprintf (stderr, "%s", _("   ('A' = 41 hex, 'B' = 42 hex, ...) "\
+      fprintf (stderr, _("   takes the file 'samhain', sets the password to "\
+	       "'ABCDEFGH'\n")); 
+      fprintf (stderr, _("   ('A' = 41 hex, 'B' = 42 hex, ...) "\
 	       "and outputs the result\n"));
-      fprintf (stderr, "%s", _("   to 'samhain.new'.\n"));
+      fprintf (stderr, _("   to 'samhain.new'.\n"));
       return  EXIT_FAILURE;
     }
@@ -279,7 +160,6 @@
   if (strlen(argv[3]) != 16)
     {
-      fprintf (stdout, 
-	       _("ERROR <new_password> |%s| has not exactly 16 chars\n"),
-	       argv[3]);
+      fprintf (stdout, _("ERROR <new_password> %s has not exactly 16 chars\n"),
+	       argv[0]);
       fflush(stdout);
       return  EXIT_FAILURE;
@@ -316,5 +196,5 @@
   (void) umask (0);
 
-  taus_seed();
+  srand(time(NULL) ^ getpid());
 
   bytecount = 0;
@@ -326,9 +206,8 @@
   oldf = open(argv[1], O_RDONLY);
 
-  nlen = strlen(argv[1])+strlen(argv[2])+2;
-  newn = (char *) malloc (nlen);
-  strncpy(newn, argv[1], nlen); newn[nlen-1] = '\0';
-  strncat(newn, ".", nlen);     newn[nlen-1] = '\0';
-  strncat(newn, argv[2], nlen); newn[nlen-1] = '\0';
+  newn = (char *) malloc (strlen(argv[1])+strlen(argv[2])+2);
+  strcpy(newn, argv[1]);
+  strcat(newn, ".");
+  strcat(newn, argv[2]);
   newf = open(newn, O_WRONLY|O_CREAT|O_TRUNC, S_IRWXU);
 
@@ -361,5 +240,5 @@
 	{
 	  suc = 1;
-	  fprintf (stdout, "%s", _("INFO   old password found\n"));
+	  fprintf (stdout, _("INFO   old password found\n"));
 	  fflush(stdout);
 	  for (i = 0; i < 8; ++i)
@@ -386,5 +265,5 @@
 		      (unsigned char) *found_it);
 
-	      ccd = (unsigned char) (256.0 * (taus_get()/(TAUS_MAX+1.0)));
+	      ccd = (unsigned char) (256.0 * rand()/(RAND_MAX+1.0));
 	      sprintf(&newpwd[i*2], _("%02x"), 
 		      (unsigned char) ccd);
@@ -399,16 +278,10 @@
 
 
-      ret = write (newf, buf, dat);
-      if (dat > 0 && ret < 0)
-	{
-	  fprintf(stdout, _("ERROR Cannot write to output file %s.\n"), newn);
-	  fflush(stdout);
-	  return EXIT_FAILURE;
-	}
+      write (newf, buf, dat);
     }
 
   if (suc == 1 && badcnt == 7)
     {
-      fprintf (stdout, "%s", _("INFO   finished\n"));
+      fprintf (stdout, _("INFO   finished\n"));
       close (newf);
       close (oldf);
@@ -420,6 +293,6 @@
   lseek (newf, 0, SEEK_SET);
 
-  fprintf (stdout, "%s", _("INFO   Not found in first pass.\n"));
-  fprintf (stdout, "%s", _("INFO   Second pass ..\n"));
+  fprintf (stdout, _("INFO   Not found in first pass.\n"));
+  fprintf (stdout, _("INFO   Second pass ..\n"));
 
   /* offset the start point
@@ -427,11 +300,5 @@
 
   dat = read (oldf, buf, (GRAB_SIZE / 2));
-  ret = write (newf, buf, dat);
-  if (dat > 0 && ret < 0)
-    {
-      fprintf(stdout, _("ERROR Cannot write to output file %s.\n"), newn);
-      fflush(stdout);
-      return EXIT_FAILURE;
-    }
+  write (newf, buf, dat);
 
   bytecount = 0;
@@ -450,5 +317,5 @@
 	{
 	  suc = 1;
-	  fprintf (stdout, "%s", _("INFO   old password found\n"));
+	  fprintf (stdout, _("INFO   old password found\n"));
 	  for (i = 0; i < 8; ++i)
 	    {
@@ -473,5 +340,5 @@
 		      (unsigned char) *found_it);
 
-	      ccd = (unsigned char) (256.0 * taus_get()/(TAUS_MAX+1.0));
+	      ccd = (unsigned char) (256.0 * rand()/(RAND_MAX+1.0));
 	      sprintf(&newpwd[i*2], _("%02x"), 
 		      (unsigned char) ccd);
@@ -484,11 +351,5 @@
 	}
 
-      ret = write (newf, buf, dat);
-      if (dat > 0 && ret < 0)
-	{
-	  fprintf(stdout, _("ERROR Cannot write to output file %s.\n"), newn);
-	  fflush(stdout);
-	  return EXIT_FAILURE;
-	}
+      write (newf, buf, dat);
     }
 
@@ -498,5 +359,5 @@
   if (suc == 1 && badcnt == 7)
     {
-      fprintf (stdout, "%s", _("INFO   finished\n"));
+      fprintf (stdout, _("INFO   finished\n"));
       fflush(stdout);
       return 0;
@@ -505,9 +366,9 @@
   if (suc == 0 || badcnt < 7)
     {
-      fprintf (stdout, "%s", _("ERROR incomplete replacement\n"));
+      fprintf (stdout, _("ERROR incomplete replacement\n"));
     }
   else 
     {
-      fprintf (stdout, "%s", _("ERROR bad replacement\n"));
+      fprintf (stdout, _("ERROR bad replacement\n"));
     }
   fflush(stdout);
